const state = {
    cart: [],
    total: 0
}

const getters = {
    cartItems(state) {
        return state.cart
    },
    total(state) {
        return state.total
    },
    cartIsEmpty(state) {
        return state.cart.length !== 0
    }
}

const mutations = {
    addToCart(state, payload) {
        let finded = state.cart.find(item => item.id == payload.product.id)

        if (finded) {
            payload.product.qty = payload.product.qty + 1
        } else {
            state.cart = [payload.product, ...state.cart]
        }
    },
    subtractFromCart(state, payload) {
        let finded = state.cart.find(item => item.id == payload.product.id)
        finded.qty = finded.qty - 1
    },
    removeFromCart(state, payload) {
        let findedIndex = state.cart.findIndex(item => item.id == payload.product.id)
        state.cart.splice(findedIndex, 1)
    },
    calculateTotal(state) {
        let sum = 0

        state.cart.forEach(item => {
            sum = sum + (item.list_price * (item.qty || 1))
        })

        state.total = sum
    }
}

const actions = {
    addToCart({ commit, dispatch }, payload) {
        commit('addToCart', {
            product: payload
        })
        
        commit('calculateTotal')

        // dispatch('setSelectedProduct', {
        //     product: null
        // })
    },
    subtractFromCart({ commit, dispatch}, payload) {
        if (payload.qty > 1) {
            commit('subtractFromCart', {
                product: payload
            })
        } else {
            commit('removeFromCart', {
                product: payload
            })     
        }
        
        commit('calculateTotal')
    },
    removeFromCart({ commit, dispatch }, payload) {
        commit('removeFromCart', {
            product: payload
        })
        
        commit('calculateTotal')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
