const state = {
    company: null
}

const getters = {
    company(state) {
        return state.company
    },
    currency(state) {
        return state.company ? state.company.currency : ''
    },
    currencySymbol(state) {
        return state.company ? state.company.currency.symbol : '$'
    }
}

const mutations = {
    setCompany(state, payload) {
        state.company = payload.company
    }
}

const actions = {
    fetchCompany({ commit, dispatch }) {
        return new Promise((resolve, reject) => {
            let ResCompany = new openerp.web.Model('res.company')

            ResCompany.call('get_company', {
                context: new openerp.web.CompoundContext()
            }).then(response => {
                commit('setCompany', {
                    company: response
                })

                dispatch('loaded', 'company')
                
                resolve()
            }).fail(error => {
                console.log(error)
                reject(error)
            })
        })
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}