const state = {
    loaded: {
        company: false,
        currencies: false,
        customers: false,
        products: false,
        journals: false,
        periods: false,
        paymentTerms: false
    },
    messages: [
        'Cargando compañía',
        'Cargando monedas',
        'Cargando clientes',
        'Cargando productos'
    ]
}

const getters = {
    messages(state) {
        return state.messages
    },
    isLoaded(state) {
        return state.loaded.company && 
               state.loaded.currencies && 
               state.loaded.customers && 
               state.loaded.products &&
               state.loaded.journals &&
               state.loaded.periods &&
               state.loaded.paymentTerms
    }
}

const mutations = {
    setLoaded(state, payload) {
        state.loaded[payload] = true
    },
    setUnloaded(state) {
        for (let module in state.loaded) {
            state.loaded[module] = false
        }
    }
}

const actions = {
    loaded({ commit }, payload) {
        commit('setLoaded', payload)
    },
    clear({ commit }) {
        commit('setUnloaded')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}